=== examples/dynamics/CMakeLists.txt ===
add_library(dynamics
  Dynamic.cpp
  Dynamic.h
  Kinetic.cpp
  Kinetic.h
  RigidBody.cpp
  RigidBody.h
)
