=== src/qhull/CMakeLists.txt ===
add_library(qhull OBJECT
	geom.c
	geom.h
	geom2.c
	global.c
	io.c
	io.h
	mem.c
	mem.h
	merge.c
	merge.h
	poly.c
	poly.h
	poly2.c
	qhull.c
	qhull.h
	qhull_a.h
	qset.c
	qset.h
	stat.c
	stat.h
	user.c
	user.h
)
